Unit AER2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AER2R(NM :Integer; N :Integer; MB :Integer;
                var A :Array of Real; var D :Array of Real;
                var E :Array of Real; var E2 :Array of Real;
                MATZ :Boolean; var Z :Array of Real);

implementation

procedure AER2R(NM :Integer; N :Integer; MB :Integer;
                var A :Array of Real; var D :Array of Real;
                var E :Array of Real; var E2 :Array of Real;
                MATZ :Boolean; var Z :Array of Real);
var
J,K,L,R,I1,I2,J1,J2,KR,MR,M1,N2,R1,UGL,MAXL,MAXR :Integer;
G,U,B1,B2,C2,F1,F2,S2,DMIN,DMINRT :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32;
begin
DMIN := Power(2.0,-64);
DMINRT := Power(2.0,-32);
{  ********** }
for J:=1 to N do
 begin
_1:
  D[J-1] := 1.0;
 end;
if ( not MATZ ) 
 then goto _4;
for J:=1 to N do
 begin
  for K:=1 to N do
   begin
_2:
    Z[(J-1)+(K-1)*NM] := 0.0;
   end;
  Z[(J-1)+(J-1)*NM] := 1.0;
_3:
 end;
_4:
M1 := MB-1;
if ( M1-1 ) < 0
 then goto _30
 else if ( M1-1 ) > 0
       then goto _5
       else goto _24;
_5:
N2 := N-2;
for K:=1 to N2 do
 begin
  MAXR := Min0(M1,N-K);
{  ********** }
  for R1:=2 to MAXR do
   begin
    R := MAXR+2-R1;
    KR := K+R;
    MR := MB-R;
    G := A[(KR-1)+(MR-1)*NM];
    A[(KR-2)+0*NM] := A[(KR-2)+(MR+0)*NM];
    UGL := K;
    J := KR;
    while ( J<=N ) do
     begin
      J1 := J-1;
      J2 := J1-1;
      if ( G = 0.0 ) 
       then goto _16;
      B1 := A[(J1-1)+0*NM]/G;
      B2 := B1*D[J1-1]/D[J-1];
      S2 := 1.0/(1.0+B1*B2);
      if ( S2 >= 0.5 ) 
       then goto _10;
      B1 := G/A[(J1-1)+0*NM];
      B2 := B1*D[J-1]/D[J1-1];
      C2 := 1.0-S2;
      D[J1-1] := C2*D[J1-1];
      D[J-1] := C2*D[J-1];
      F1 := 2.0*A[(J-1)+(M1-1)*NM];
      F2 := B1*A[(J1-1)+(MB-1)*NM];
      A[(J-1)+(M1-1)*NM] := -B2*(B1*A[(J-1)+(M1-1)*NM]-A[(J-1)+(MB-1)*NM])-F2+A[(J-1)+(M1-1)*NM];
      A[(J1-1)+(MB-1)*NM] := B2*(B2*A[(J-1)+(MB-1)*NM]+F1)+A[(J1-1)+(MB-1)*NM];
      A[(J-1)+(MB-1)*NM] := B1*(F2-F1)+A[(J-1)+(MB-1)*NM];
      for L:=UGL to J2 do
       begin
        I2 := MB-J+L;
        U := A[(J1-1)+(I2+0)*NM]+B2*A[(J-1)+(I2-1)*NM];
        A[(J-1)+(I2-1)*NM] := -B1*A[(J1-1)+(I2+0)*NM]+A[(J-1)+(I2-1)*NM];
        A[(J1-1)+(I2+0)*NM] := U;
_6:
       end;
      UGL := J;
      A[(J1-1)+0*NM] := A[(J1-1)+0*NM]+B2*G;
      if ( J = N ) 
       then goto _8;
      MAXL := Min0(M1,N-J1);
      for L:=2 to MAXL do
       begin
        I1 := J1+L;
        I2 := MB-L;
        U := A[(I1-1)+(I2-1)*NM]+B2*A[(I1-1)+(I2+0)*NM];
        A[(I1-1)+(I2+0)*NM] := -B1*A[(I1-1)+(I2-1)*NM]+A[(I1-1)+(I2+0)*NM];
        A[(I1-1)+(I2-1)*NM] := U;
_7:
       end;
      I1 := J+M1;
      if ( I1 > N ) 
       then goto _8;
      G := B2*A[(I1-1)+0*NM];
_8:
      if ( not MATZ ) 
       then goto _15;
      for L:=1 to N do
       begin
        U := Z[(L-1)+(J1-1)*NM]+B2*Z[(L-1)+(J-1)*NM];
        Z[(L-1)+(J-1)*NM] := -B1*Z[(L-1)+(J1-1)*NM]+Z[(L-1)+(J-1)*NM];
        Z[(L-1)+(J1-1)*NM] := U;
_9:
       end;
      goto _15;
_10:
      U := D[J1-1];
      D[J1-1] := S2*D[J-1];
      D[J-1] := S2*U;
      F1 := 2.0*A[(J-1)+(M1-1)*NM];
      F2 := B1*A[(J-1)+(MB-1)*NM];
      U := B1*(F2-F1)+A[(J1-1)+(MB-1)*NM];
      A[(J-1)+(M1-1)*NM] := B2*(B1*A[(J-1)+(M1-1)*NM]-A[(J1-1)+(MB-1)*NM])+F2-A[(J-1)+(M1-1)*NM];
      A[(J1-1)+(MB-1)*NM] := B2*(B2*A[(J1-1)+(MB-1)*NM]+F1)+A[(J-1)+(MB-1)*NM];
      A[(J-1)+(MB-1)*NM] := U;
      for L:=UGL to J2 do
       begin
        I2 := MB-J+L;
        U := B2*A[(J1-1)+(I2+0)*NM]+A[(J-1)+(I2-1)*NM];
        A[(J-1)+(I2-1)*NM] := -A[(J1-1)+(I2+0)*NM]+B1*A[(J-1)+(I2-1)*NM];
        A[(J1-1)+(I2+0)*NM] := U;
_11:
       end;
      UGL := J;
      A[(J1-1)+0*NM] := B2*A[(J1-1)+0*NM]+G;
      if ( J = N ) 
       then goto _13;
      MAXL := Min0(M1,N-J1);
      for L:=2 to MAXL do
       begin
        I1 := J1+L;
        I2 := MB-L;
        U := B2*A[(I1-1)+(I2-1)*NM]+A[(I1-1)+(I2+0)*NM];
        A[(I1-1)+(I2+0)*NM] := -A[(I1-1)+(I2-1)*NM]+B1*A[(I1-1)+(I2+0)*NM];
        A[(I1-1)+(I2-1)*NM] := U;
_12:
       end;
      I1 := J+M1;
      if ( I1 > N ) 
       then goto _13;
      G := A[(I1-1)+0*NM];
      A[(I1-1)+0*NM] := B1*A[(I1-1)+0*NM];
_13:
      if ( not MATZ ) 
       then goto _15;
      for L:=1 to N do
       begin
        U := B2*Z[(L-1)+(J1-1)*NM]+Z[(L-1)+(J-1)*NM];
        Z[(L-1)+(J-1)*NM] := -Z[(L-1)+(J1-1)*NM]+B1*Z[(L-1)+(J-1)*NM];
        Z[(L-1)+(J1-1)*NM] := U;
_14:
       end;
_15:
      inc(J,M1);
     end;
_16:
   end;
  if ( ((K) Mod (64)) <> 0 ) 
   then goto _23;
{  ********** }
  for J:=K to N do
   begin
    if ( D[J-1] >= DMIN ) 
     then goto _22;
    MAXL := Max0(1,MB+1-J);
    for L:=MAXL to M1 do
     begin
_17:
      A[(J-1)+(L-1)*NM] := DMINRT*A[(J-1)+(L-1)*NM];
     end;
    if ( J = N ) 
     then goto _19;
    MAXL := Min0(M1,N-J);
    for L:=1 to MAXL do
     begin
      I1 := J+L;
      I2 := MB-L;
      A[(I1-1)+(I2-1)*NM] := DMINRT*A[(I1-1)+(I2-1)*NM];
_18:
     end;
_19:
    if ( not MATZ ) 
     then goto _21;
    for L:=1 to N do
     begin
_20:
      Z[(L-1)+(J-1)*NM] := DMINRT*Z[(L-1)+(J-1)*NM];
     end;
_21:
    A[(J-1)+(MB-1)*NM] := DMIN*A[(J-1)+(MB-1)*NM];
    D[J-1] := D[J-1]/DMIN;
_22:
   end;
_23:
 end;
{ **********}
_24:
for J:=2 to N do
 begin
_25:
  E[J-1] := Sqrt(D[J-1]);
 end;
if ( not MATZ ) 
 then goto _28;
for J:=1 to N do
 begin
  for K:=2 to N do
   begin
_26:
    Z[(J-1)+(K-1)*NM] := E[K-1]*Z[(J-1)+(K-1)*NM];
   end;
_27:
 end;
_28:
U := 1.0;
for J:=2 to N do
 begin
  A[(J-1)+(M1-1)*NM] := U*E[J-1]*A[(J-1)+(M1-1)*NM];
  U := E[J-1];
  E2[J-1] := IntPower(A[(J-1)+(M1-1)*NM],2);
  A[(J-1)+(MB-1)*NM] := D[J-1]*A[(J-1)+(MB-1)*NM];
  D[J-1] := A[(J-1)+(MB-1)*NM];
  E[J-1] := A[(J-1)+(M1-1)*NM];
_29:
 end;
D[0] := A[0+(MB-1)*NM];
E[0] := 0.0;
E2[0] := 0.0;
goto _32;
_30:
for J:=1 to N do
 begin
  D[J-1] := A[(J-1)+(MB-1)*NM];
  E[J-1] := 0.0;
  E2[J-1] := 0.0;
_31:
 end;
_32:
end;

end.
